//afbeelding-103-4.js Hoort bij vierde pagina

document.addEventListener("DOMContentLoaded", cssvCustomControls);

function cssvCustomControls() {

	var videoNodeList, len, i, width, sourceNodeList, j, extension;

	videoNodeList = document.getElementsByTagName("video");
	len = videoNodeList.length;
	if (len === 0) return false;
	for (i = 0; i < len; i++) {
		width = parseInt(videoNodeList[i].getAttribute("data-smscr"), 10);
		if (width > 0) break;
	}

	if ((width > 0) && ((window.innerWidth < width) || (window.innerHeight < width))) {
		for (i = 0; i < len; i++) {
			if (parseInt(videoNodeList[i].getAttribute("data-smscr"), 10) > 0) {
				sourceNodeList = videoNodeList[i].querySelectorAll("source");
				for (j = 0; j < sourceNodeList.length; j++) {
					if (parseInt(sourceNodeList[j].getAttribute("data-smscr"), 10) > 0) {
						extension = sourceNodeList[j].src.substring(sourceNodeList[j].src.lastIndexOf('.') + 1);
						if (videoNodeList[i].canPlayType("video/" + extension) !== "") {
							videoNodeList[i].src = sourceNodeList[j].src;
							break;
						}
					}
				}
			}
		}
		return false;
	}

	window.addEventListener("load", function () {setTimeout(function () {afterPageLoaded(); }, 1); });
	window.addEventListener("load", function () {setTimeout(function () {obtainDurationAgain(); }, 1000); });

	var durationUnknownText = "Deze functie is pas beschikbaar, als de speelduur van de video bekend is.<br>Om een of andere reden is de speelduur van de video nog niet bekend. Mogelijk is de speelduur nog helemaal niet opgevraagd. Sommige browsers vragen deze pas op, als de video wordt afgespeeld. Mogelijk is de verbinding met de server niet optimaal. Of er is 'n andere reden. Meestal komt deze functie alsnog beschikbaar, als de video wordt gestart. Na sluiting van deze melding krijgt de Speelknop van de bijbehorende video focus.",
	durationDivId = "duration-div",
	durationDivAriaLabel = "Functie nog niet beschikbaar",
	durationParId = "duration-par",
	durationButtonId = "duration-button",
	durationButtonText = "Sluit melding",

	wrapperDivClassId = "videobox",

	chooseDivId = "kiezen-div",
	chooseDivAriaLabel = "Kiezen tussen standaard- of aangepaste videospelers",
	chooseParClassId = "kiezen-par",
	chooseLabelClassId = "kiezen-label",
	chooseLabelCustomText = "O, iets nieuws, dolletjes! Daar raak ik opgewonden van, stouterd, hihihi! Ik kies voor de aangepaste besturing voor de video: ",
	chooseLabelDefaultText = "Iets nieuws. Jasses, wat eng. Misschien zijn het wel gesluierde knoppen. Ik eet alleen wat ik ken en wil m'n eigenste standaardbesturing voor de video: ",
	chooseRadioClassId = "kiezen-knop",
	chooseRadioTabIndex = "15",
	chooseName = "kiezen",
	chooseRadioDefaultTitle = "Standaardbesturing",
	chooseRadioCustomTitle = "Aangepaste besturing",

	videoClassId = "video",
	videoAriaLabel = "Video nummer",

	controlsDivClassId = "controls",

	playPauseClassId = "play",
	notPlayingClass = "not-playing",
	playTitle = "Afspelen",
	pauseTitle = "Pauzeren",
	playPauseTabIndex = "1",
	playAriaLabel = "Afspelen",
	pauseAriaLabel = "Pauzeren",

	soundDivClassId = "sound",
	soundStartVolume = "0.5",

	softerClassId = "softer",
	softerTitle = "Zachter",
	softerTabIndex = "9",
	softerAriaLabel = "Zachter",

	ariaVolumeClassId = "aria-volume",
	ariaVolumeText = "procent",

	percentageClassId = "percentage",
	percentageTitle = "Geluidssterkte",
	percentageAriaLabel = "Geluidssterkte",

	louderClassId = "louder",
	louderTitle = "Harder",
	louderTabIndex = "10",
	louderAriaLabel = "Harder",

	muteClassId = "mute",
	mutedClass = "muted",
	muteTitle = "Geluid uit",
	unmuteTitle = "Geluid aan",
	muteTabIndex = "2",
	muteAriaLabel = "Geluid uit",
	unmuteAriaLabel = "Geluid aan",

	soundSliderClassId = "sound-slider",

	soundSliderBeamClassId = "sound-slider-beam",
	soundSliderBeamTitle = "Sleepbalk volume",
	soundSliderBeamTabIndex = "",
	soundSliderBeamAriaLabel = "Sleepbalk volume",

	soundSliderButtonClassId = "sound-slider-button",
	soundSliderButtonTitle = "Sleepbalk volume",

	imageDivClassId = "image",

	toBeginClassId = "to-begin",
	toBeginTitle = "Naar begin video",
	toBeginTabIndex = "4",
	toBeginAriaLabel = "Naar begin video",

	fiveBackClassId = "five-back",
	fiveBackTitle = "Vijf procent terug",
	fiveBackTabIndex = "",
	fiveBackAriaLabel = "Vijf procent terug",

	tenBackClassId = "ten-back",
	tenBackTitle = "Tien seconden terug",
	tenBackTabIndex = "6",
	tenBackAriaLabel = "Tien seconden terug",

	tenForwardClassId = "ten-forward",
	tenForwardTitle = "Tien seconden verder",
	tenForwardTabIndex = "7",
	tenForwardAriaLabel = "Tien seconden verder",

	fiveForwardClassId = "five-forward",
	fiveForwardTitle = "Vijf procent verder",
	fiveForwardTabIndex = "",
	fiveForwardAriaLabel = "Vijf procent verder",

	toEndClassId = "to-end",
	toEndTitle = "Naar einde video",
	toEndTabIndex = "5",
	toEndAriaLabel = "Naar einde video",

	fullscreenClassId = "fullscreen",
	fullscreenTitle = "Volledig scherm",
	fullscreenTabIndex = "8",
	fullscreenAriaLabel = "Volledig scherm",

	speedClassId = "speed",
	speedAriaLabel = "Snelheid afspelen instellen",

	speedTabIndex = "",
	speedName = "knop-snelheid",

	speedHalfClassId = "speed-half",
	speedHalfTitle = "Halve snelheid",
	speedHalfAriaLabel = "Halve snelheid",
	speedHalfLabelClassId = "speed-half-label",
	speedHalfLabelTitle = "Halve snelheid",
	speedHalfLabelText = "0,5x",

	speedDefaultClassId = "speed-default",
	speedDefaultTitle = "Normale snelheid",
	speedDefaultAriaLabel = "Normale snelheid",
	speedDefaultLabelClassId = "speed-default-label",
	speedDefaultLabelTitle = "Normale snelheid",
	speedDefaultLabelText = "1x",

	speedOneHalfClassId = "speed-one-half",
	speedOneHalfTitle = "Anderhalve snelheid",
	speedOneHalfAriaLabel = "Anderhalve snelheid",
	speedOneHalfLabelClassId = "speed-one-half-label",
	speedOneHalfLabelTitle = "Anderhalve snelheid",
	speedOneHalfLabelText = "1,5x",

	speedDoubleClassId = "speed-double",
	speedDoubleTitle = "Dubbele snelheid",
	speedDoubleAriaLabel = "Dubbele snelheid",
	speedDoubleLabelClassId = "speed-double-label",
	speedDoubleLabelTitle = "Dubbele snelheid",
	speedDoubleLabelText = "2x",

	imageSliderClassId = "image-slider",

	imageSliderBeamClassId = "image-slider-beam",
	imageSliderBeamTitle = "Sleepbalk afspelen",
	imageSliderBeamAriaLabel = "Sleepbalk afspelen",
	imageSliderBeamTabIndex = "3",

	imageSliderButtonClassId = "image-slider-button",
	imageSliderButtonTitle = "Sleepbalk afspelen",

	elapsedClassId = "elapsed",
	elapsedTitle = "Verstreken",
	elapsedAriaLabel = "Verstreken",

	ariaElapsedClassId = "aria-elapsed",
	ariaStartVideoText = "Begin video",
	ariaEndVideoText = "Einde video",
	ariaHourText = "uur",
	ariaMinutesText = "minuut",
	ariaSecondsText = "seconden",

	remainingClassId = "remaining",
	remainingTitle = "Resterend",
	remainingAriaLabel = "Resterend",

	durationClassId = "duration",
	durationTitle = "Speelduur",
	durationAriaLabel = "Speelduur",

	soundSlidingAllowed, imageSlidingAllowed, ariaSpeakTime, ariaSpeakTimeLater, ariaSpeakVolume, ariaSpeakVolumeLater, pointerRepeat, wrapperDivNodeList, parents, controlsDivNodeList, playPauseNodeList, soundDivNodeList, softerNodeList, ariaVolumeNodeList, percentageNodeList, louderNodeList, muteNodeList, soundSliderBeamNodeList, soundSliderButtonNodeList, imageDivNodeList, toBeginNodeList, fiveBackNodeList, tenBackNodeList, tenForwardNodeList, fiveForwardNodeList, toEndNodeList, fullscreenNodeList, speedHalfNodeList, speedDefaultNodeList, speedOneHalfNodeList, speedDoubleNodeList, imageSliderBeamNodeList, imageSliderButtonNodeList, remainingNodeList, elapsedNodeList, ariaElapsedNodeList, durationNodeList, elapsed, showingDurationText;

	if (durationUnknownText) {
		durationDivId = checkValue("durationDivId", durationDivId, "duration-div");
		durationParId = checkValue("durationParId", durationParId, "duration-par");
		durationButtonId = checkValue("durationButtonId", durationButtonId, "duration-button");
	}
	chooseDivId = checkValue("chooseDivId", chooseDivId, "choose-div");
	chooseParClassId = checkValue("chooseParClassId", chooseParClassId, "choose-par");
	chooseLabelClassId = checkValue("chooseLabelClassId", chooseLabelClassId, "choose-label");
	chooseRadioClassId = checkValue("chooseRadioClassId", chooseRadioClassId, "choose-button");
	chooseName = checkValue("chooseName", chooseName, "choose");
	videoClassId = checkValue("videoClassId", videoClassId, "video");
	videoAriaLabel = checkValue("videoAriaLabel", videoAriaLabel, "Video number");
	controlsDivClassId = checkValue("controlsDivClassId", controlsDivClassId, "controls");
	playPauseClassId = checkValue("plauPauseClassId", playPauseClassId, "play");
	notPlayingClass = checkValue("notPlayingClass", notPlayingClass, "not-playing");
	soundDivClassId = checkValue("soundDivClassId", soundDivClassId, "sound");
	soundStartVolume = (isNaN(parseFloat(soundStartVolume))) ? 0.5 : soundStartVolume;
	softerClassId = checkValue("softerClassId", softerClassId, "softer");
	ariaVolumeClassId = checkValue("ariaVolumeClassId", ariaVolumeClassId, "aria-volume");
	percentageClassId = checkValue("percentageClassId", percentageClassId, "percentage");
	louderClassId = checkValue("louderClassId", louderClassId, "louder");
	muteClassId = checkValue("muteClassId", muteClassId, "mute");
	mutedClass = checkValue("mutedClass", mutedClass, "muted");
	soundSliderClassId = checkValue("soundSliderClassId", soundSliderClassId, "sound-slider");
	soundSliderBeamClassId = checkValue("soundSliderBeamClassId", soundSliderBeamClassId, "sound-slider-beam");
	soundSliderButtonClassId = checkValue("soundSliderButtonClassId", soundSliderButtonClassId, "sound-slider-button");
	imageDivClassId = checkValue("imageDivClassId", imageDivClassId, "image");
	toBeginClassId = checkValue("toBeginClassId", toBeginClassId, "to-begin");
	fiveBackClassId = checkValue("fiveBackClassId", fiveBackClassId, "five-back");
	tenBackClassId = checkValue("tenBackClassId", tenBackClassId, "ten-back");
	tenForwardClassId = checkValue("tenForwardClassId", tenForwardClassId, "ten-forward");
	fiveForwardClassId = checkValue("fiveForwardClassId", fiveForwardClassId, "five-forward");
	toEndClassId = checkValue("toEndClassId", toEndClassId, "to-end");
	fullscreenClassId = checkValue("fullscreenClassId", fullscreenClassId, "fullscreen");
	speedClassId = checkValue("speedClassId", speedClassId, "speed");
	speedName = checkValue("speedName", speedName, "button-speed");
	speedHalfClassId = checkValue("speedHalfClassId", speedHalfClassId, "speed-half");
	speedHalfLabelClassId = checkValue("speedHalfLabelClassId", speedHalfLabelClassId, "speed-half-label");
	speedDefaultClassId = checkValue("speedDefaultClassId", speedDefaultClassId, "speed-default");
	speedDefaultLabelClassId = checkValue("speedDefaultLabelClassId", speedDefaultLabelClassId, "speed-default-label");
	speedOneHalfClassId = checkValue("speedOneHalfClassId", speedOneHalfClassId, "speed-one-half");
	speedOneHalfLabelClassId = checkValue("speedOneHalfLabelClassId", speedOneHalfLabelClassId, "speed-one-half-label");
	speedDoubleClassId = checkValue("speedDoubleClassId", speedDoubleClassId, "speed-double");
	speedDoubleLabelClassId = checkValue("speedDoubleLabelClassId", speedDoubleLabelClassId, "speed-double-label");
	imageSliderClassId = checkValue("imageSliderClassId", imageSliderClassId, "image-slider");
	imageSliderBeamClassId = checkValue("imageSliderBeamClassId", imageSliderBeamClassId, "image-slider-beam");
	imageSliderButtonClassId = checkValue("imageSliderButtonClassId", imageSliderButtonClassId, "image-slider-button");
	elapsedClassId = checkValue("elapsedClassId", elapsedClassId, "elapsed");
	ariaElapsedClassId = checkValue("ariaElapsedClassId", ariaElapsedClassId, "aria-elapsed");
	remainingClassId = checkValue("remainingClassId", remainingClassId, "remaining");
	durationClassId = checkValue("durationClassId", durationClassId, "duration");

	showingDurationText = false;		

	soundSlidingAllowed = -1;
	imageSlidingAllowed = -1;
	ariaSpeakTime = -1;
	ariaSpeakVolume = -1;
	document.addEventListener("pointerup", function () {
		soundSlidingAllowed = -1;
		imageSlidingAllowed  = -1;
		ariaSpeakTimeLater = setTimeout(speakTime, 100);
		ariaSpeakVolumeLater = setTimeout(speakVolume, 100);
	});
	document.addEventListener("pointerdown", function () {
		clearTimeout(ariaSpeakTimeLater);
		clearTimeout(ariaSpeakVolumeLater);
	});
	document.addEventListener("keyup", function () {
		ariaSpeakTimeLater = setTimeout(speakTime, 100);
		ariaSpeakVolumeLater = setTimeout(speakVolume, 100);
	});
	document.addEventListener("keydown", function () {
		clearTimeout(ariaSpeakTimeLater);
		clearTimeout(ariaSpeakVolumeLater);
	});

	pointerRepeat = -1;
	document.addEventListener("pointerup", stopPointerRepeat);

	wrapperDivNodeList = makeWrapperDivNodeList();
	if (!wrapperDivNodeList) {
		return false;
	}

	makeChoose();

	videoNodeList = document.querySelectorAll("." + wrapperDivClassId + " video");

	Array.prototype.map.call(wrapperDivNodeList, function (e, i) {	
		if (!addControls(i)) {
			return false;
		}
	});
	Array.prototype.map.call(wrapperDivNodeList, function (e) {
		e.setAttribute("data-duration", "unknown");
		e.setAttribute("data-volume", "percent-" + twoDigits(100 * soundStartVolume));
		e.setAttribute("data-played", "percent-00");
	});
	
	controlsDivNodeList = document.querySelectorAll("." + wrapperDivClassId + " ." + controlsDivClassId);

	Array.prototype.map.call(videoNodeList, function (e, i) {
		e.removeAttribute("controls");
		e.volume = soundStartVolume;
		e.className = videoClassId;
		e.id = videoClassId + "-" + (i + 1);
		e.addEventListener("ended", finished);
		if (!e.getAttribute("aria-label") && !e.getAttribute("aria-labelledby") && !e.getAttribute("aria-describedby")) {
			e.setAttribute("aria-label", videoAriaLabel + " " +  (i + 1));
		}
	});

	parents = "." + wrapperDivClassId + " ." + controlsDivClassId + " .";
	playPauseNodeList = document.querySelectorAll(parents + playPauseClassId);

	soundDivNodeList = document.querySelectorAll(parents + soundDivClassId);
	softerNodeList = document.querySelectorAll(parents + softerClassId);
	ariaVolumeNodeList = document.querySelectorAll(parents + ariaVolumeClassId);
	percentageNodeList = document.querySelectorAll(parents + percentageClassId);
	louderNodeList = document.querySelectorAll(parents + louderClassId);
	muteNodeList = document.querySelectorAll(parents + muteClassId);
	soundSliderBeamNodeList = document.querySelectorAll(parents + soundSliderBeamClassId);
	soundSliderButtonNodeList = document.querySelectorAll(parents + soundSliderButtonClassId);

	imageDivNodeList = document.querySelectorAll(parents + imageDivClassId);

	toBeginNodeList = document.querySelectorAll(parents + toBeginClassId);
	fiveBackNodeList = document.querySelectorAll(parents + fiveBackClassId);
	tenBackNodeList = document.querySelectorAll(parents + tenBackClassId);
	tenForwardNodeList = document.querySelectorAll(parents + tenForwardClassId);
	fiveForwardNodeList = document.querySelectorAll(parents + fiveForwardClassId);
	toEndNodeList = document.querySelectorAll(parents + toEndClassId);
	fullscreenNodeList = document.querySelectorAll(parents + fullscreenClassId);
	speedHalfNodeList = document.querySelectorAll(parents + speedHalfClassId);
	speedDefaultNodeList = document.querySelectorAll(parents + speedDefaultClassId);
	speedOneHalfNodeList = document.querySelectorAll(parents + speedOneHalfClassId);
	speedDoubleNodeList = document.querySelectorAll(parents + speedDoubleClassId);
	imageSliderBeamNodeList = document.querySelectorAll(parents + imageSliderBeamClassId);
	imageSliderButtonNodeList = document.querySelectorAll(parents + imageSliderButtonClassId);
	
	elapsedNodeList = document.querySelectorAll(parents + elapsedClassId);
	ariaElapsedNodeList = document.querySelectorAll(parents + ariaElapsedClassId);
	remainingNodeList = document.querySelectorAll(parents + remainingClassId);
	durationNodeList = document.querySelectorAll(parents + durationClassId);

	len = controlsDivNodeList.length;
	for (i = 0; i < len; i++) {
		controlsDivNodeList[i].setAttribute("style", "-ms-touch-action: none; touch-action: none; -moz-user-select: none; -ms-user-select: none; -webkit-user-select: none; -user-select: none;");
		controlsDivNodeList[i].addEventListener("contextmenu", noContext);

		playPauseNodeList[i].addEventListener("click", playPause);

		softerNodeList[i].addEventListener("keydown", keySofterLouder);
		softerNodeList[i].addEventListener("pointerdown", pointerSofterLouder);
		softerNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		louderNodeList[i].addEventListener("keydown", keySofterLouder);
		louderNodeList[i].addEventListener("pointerdown", pointerSofterLouder);
		louderNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		muteNodeList[i].addEventListener("click", mute);

		soundSliderBeamNodeList[i].addEventListener("pointerdown", soundBeginSliding);
		soundSliderBeamNodeList[i].addEventListener("keydown", soundSliderKey);
		soundSliderButtonNodeList[i].addEventListener("pointerdown", soundBeginSliding);
		soundSliderButtonNodeList[i].style.position = "absolute";
		soundSliderButtonNodeList[i].style.visibility = "hidden";

		toBeginNodeList[i].addEventListener("click", toBegin);
		fiveBackNodeList[i].addEventListener("keydown", keyBackForward);
		fiveBackNodeList[i].addEventListener("keyup", function (e) {showDurationText(true, parseInt(this.id.substr(-1), 10) - 1, e.keyCode); });
		fiveBackNodeList[i].addEventListener("pointerdown", pointerBackForward);
		fiveBackNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		tenBackNodeList[i].addEventListener("keydown", keyBackForward);
		tenBackNodeList[i].addEventListener("keyup", function (e) {showDurationText(true, parseInt(this.id.substr(-1), 10) - 1, e.keyCode); });
		tenBackNodeList[i].addEventListener("pointerdown", pointerBackForward);
		tenBackNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		tenForwardNodeList[i].addEventListener("keydown", keyBackForward);
		tenForwardNodeList[i].addEventListener("keyup", function (e) {showDurationText(true, parseInt(this.id.substr(-1), 10) - 1, e.keyCode); });
		tenForwardNodeList[i].addEventListener("pointerdown", pointerBackForward);
		tenForwardNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		fiveForwardNodeList[i].addEventListener("keydown", keyBackForward);
		fiveForwardNodeList[i].addEventListener("keyup", function (e) {showDurationText(true, parseInt(this.id.substr(-1), 10) - 1, e.keyCode); });
		fiveForwardNodeList[i].addEventListener("pointerdown", pointerBackForward);
		fiveForwardNodeList[i].addEventListener("pointerout", stopPointerRepeat);
		toEndNodeList[i].addEventListener("click", toEnd);
		fullscreenNodeList[i].addEventListener("click", fullscreen);
		speedHalfNodeList[i].addEventListener("change", changeSpeed);
		speedDefaultNodeList[i].addEventListener("change", changeSpeed);
		speedOneHalfNodeList[i].addEventListener("change", changeSpeed);
		speedDoubleNodeList[i].addEventListener("change", changeSpeed);
		
		imageSliderBeamNodeList[i].addEventListener("pointerdown", imageBeginSliding);
		imageSliderBeamNodeList[i].addEventListener("keydown", imageSliderKey);
		imageSliderButtonNodeList[i].addEventListener("pointerdown", imageBeginSliding);
		imageSliderButtonNodeList[i].style.position = "absolute";
	}
	document.addEventListener("keydown", nextVideo);

	videoNodeList[0].volume = 0.3;
	if (videoNodeList[0].volume === 1) {
		for (i = 0; i < len; i++) {
			wrapperDivNodeList[i].setAttribute("data-sound", "no");
		}
	} else {
		for (i = 0; i < len; i++) {
			wrapperDivNodeList[i].setAttribute("data-sound", "yes");
		}
	}
	videoNodeList[0].volume = soundStartVolume;

	function makeWrapperDivNodeList() {
		wrapperDivNodeList = document.getElementsByClassName(wrapperDivClassId);
		if (wrapperDivNodeList.length === 0) {
			alert("No elements with class = '" + wrapperDivClassId + "' were found! \nEach <video> MUST live inside an element with this class. \nControl will be given back to the default built-in controls for <video>.");
			return false;
		}

		Array.prototype.map.call(wrapperDivNodeList, function (e, i) {
			e.id = wrapperDivClassId + "-" + (i + 1);
		});
		return wrapperDivNodeList;
	}

	function makeChoose() {
		var docfrag = document.createDocumentFragment(),
			i, len, el;

		el = document.createElement("div");
		el.id = chooseDivId;
		el.setAttribute("role", "radiogroup");
		el.setAttribute("aria-label", chooseDivAriaLabel);
		docfrag.appendChild(el);
		for (i = 0; i < 2; i++) {
			el = makeElement({
				indexNr: i,
				tagName: "p",
				classId: chooseParClassId
			});
			docfrag.firstChild.appendChild(el);
		}

		el = makeElement({
			indexNr: 0,
			tagName: "label",
			classId: chooseLabelClassId,
			isFor: chooseRadioClassId,
			innerHtml: chooseLabelCustomText
		});
		docfrag.firstChild.firstChild.appendChild(el);
		el = makeElement({
			indexNr: 0,
			tagName: "input",
			type: "radio",
			classId: chooseRadioClassId,
			name: chooseName,
			title: chooseRadioCustomTitle,
			checked: true,
			ariaChecked: [true]
		});
		if (chooseRadioTabIndex) {
			el.tabIndex = chooseRadioTabIndex;
		}
		el.addEventListener("change", function () {
			this.setAttribute("aria-checked", true);
			document.getElementById(chooseRadioClassId + "-" + 2).setAttribute("aria-checked", false);
			len = videoNodeList.length;
			for (i = 0; i < len; i++) {
				videoNodeList[i].removeAttribute("controls");
				controlsDivNodeList[i].style.display = "block";
			}
			document.body.setAttribute("style", "zoom: 1.0001");
		});
		docfrag.firstChild.firstChild.appendChild(el);

		el = makeElement({
			indexNr: 1,
			tagName: "label",
			classId: chooseLabelClassId,
			isFor: chooseRadioClassId,
			innerHtml: chooseLabelDefaultText
		});
		docfrag.firstChild.lastChild.appendChild(el);
		el = makeElement({
			indexNr: 1,
			tagName: "input",
			type: "radio",
			classId: chooseRadioClassId,
			name: chooseName,
			title: chooseRadioDefaultTitle,
			ariaChecked: [false]
		});
		if (chooseRadioTabIndex) {
			el.tabIndex = chooseRadioTabIndex;
		}
		el.addEventListener("change", function () {
			this.setAttribute("aria-checked", true);
			document.getElementById(chooseRadioClassId + "-" + 1).setAttribute("aria-checked", false);
			len = videoNodeList.length;
			for (i = 0; i < len; i++) {
				videoNodeList[i].setAttribute("controls", "controls");
				controlsDivNodeList[i].style.display = "none";
			}
			document.body.setAttribute("style", "zoom: 1");
		});
		docfrag.firstChild.lastChild.appendChild(el);

		document.body.insertBefore(docfrag, document.body.firstChild);
	}

	function checkValue(varName, varValue, defaultValue) {

		if ((!varValue) || (typeof varValue !== "string")) {
			alert("The class, id, classId, name or aria-label filled in after   '" + varName + "'   is missing or invalid. Its current (wrong) value is   '" + varValue + "'   . A valid value is absolutely necessary for running this script.\nTo prevent errors in this script the current (wrong) value will be replaced with its default value   '" + defaultValue + "'   . You should fill in a correct value to prevent problems with parsing css etc.\n\nCorrect values:\nIf the name ends on Class, Id or ClassId: any valid class or id like used in css between quotes.\nIf the name ends on Name: any valid name like used in html for radio buttons etc. between quotes.\nIf the name ends on AriaLabel: a normal sentence between quotes (spaces allowed).");
			varValue = defaultValue;
		}
		return varValue;
	}

	function makeElement(options) {
		var orderNr = "-" + (options.indexNr + 1),
		el = document.createElement(options.tagName);

		if (options.type) {
			el.setAttribute("type", options.type);
		}

		if (options.classId) {
			el.className = options.classId;
			el.id = options.classId + orderNr;
		}

		if (options.name) {
			el.name = options.name;
		}

		if (options.value) {
			el.value = options.value;
		}

		if (options.isFor) {
			el.htmlFor = options.isFor + orderNr;
		}

		if (options.title) {
			el.title = options.title;
		}

		if (options.tabIndex) {
			if (options.tabIndex === "0" || options.tabIndex === "-1") {
				el.tabIndex = options.tabIndex;
			} else {
				el.tabIndex = (Math.abs(100 * orderNr)) + parseInt(options.tabIndex, 10);
			}
		}

		if (options.innerHtml) {
			el.innerHTML = options.innerHtml;
		}

		if (options.checked) {
			el.checked = options.checked;
		}

		if (options.ariaChecked) {
			el.setAttribute("aria-checked", options.ariaChecked[0]);
		}

		if (options.ariaControls) {
			el.setAttribute("aria-controls", options.ariaControls);
		}

		if (options.ariaLabel) {
			el.setAttribute("aria-label", options.ariaLabel);
		}

		if (options.ariaLive) {
			el.setAttribute("aria-live", options.ariaLive);
		}

		if (options.ariaRole) {
			el.setAttribute("role", options.ariaRole);
		}

		if (options.ariaHidden) {
			el.setAttribute("aria-hidden", options.ariaHidden[0]);
		}

		if (options.ariaValue) {
			el.setAttribute("aria-valuemin", options.ariaValue[0]);
			el.setAttribute("aria-valuemax", options.ariaValue[1]);
		}

		if (options.data) {
			el.setAttribute(options.data[0], options.data[1]);
		}
	
		return el;
	}

	function addControls(indexNr) {
		var wrapper = document.getElementById(wrapperDivClassId + "-" + (indexNr + 1)),
			eList = wrapper.children,
			len = eList.length,
			i, hasVideo, videoId, docfrag, el, volumeDocfrag, imageDocfrag;

		for (i = 0; i < len; i++) {
			if (eList[i].tagName === "VIDEO") {
				hasVideo = true;
				break;
			}
		}
		if (!hasVideo) {
			wrapper.style.borderColor = "red";
			wrapper.style.borderWidth = "3px";
			wrapper.style.borderStyle = "solid";
			alert("The red bordered element with id '" + wrapper.id + "' has no <video>-element inside. Because of this error this script cannot run. Inside each element with class '" + wrapperDivClassId + "' MUST a <video>-element be present. This script will terminate now. Videos still can be played with the default built-in videoplayer.");
			return false;
		}

		videoId = videoClassId + "-" + (indexNr + 1);
		
		docfrag = document.createDocumentFragment();

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: controlsDivClassId,
			ariaRole: "group"
		});
		docfrag.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: playPauseClassId,
			title: playTitle,
			tabIndex: playPauseTabIndex,
			ariaControls: videoId,
			ariaLabel: playAriaLabel
		});
		el.className += " " + notPlayingClass;
		docfrag.firstChild.appendChild(el);

		volumeDocfrag = document.createDocumentFragment();
		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: soundDivClassId,
			ariaLabel: "sound controls",
			ariaRole: "group"
		});
		volumeDocfrag.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: softerClassId,
			tabIndex: softerTabIndex,
			title: softerTitle,
			ariaControls: videoId,
			ariaLabel: softerAriaLabel
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: ariaVolumeClassId,
			ariaLive: "polite"
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: percentageClassId,
			title: percentageTitle,
			innerHtml: 100 * soundStartVolume + "%",
			ariaLabel: percentageAriaLabel
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: louderClassId,
			title: louderTitle,
			tabIndex: louderTabIndex,
			ariaControls: videoId,
			ariaLabel: louderAriaLabel
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: muteClassId,
			title: muteTitle,
			tabIndex: muteTabIndex,
			ariaControls: videoId,
			ariaLabel: muteAriaLabel
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: soundSliderClassId
		});
		volumeDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: soundSliderBeamClassId,
			title: soundSliderBeamTitle,
			tabIndex: soundSliderBeamTabIndex,
			ariaRole: "slider",
			ariaControls: videoId,
			ariaLabel: soundSliderBeamAriaLabel,
			ariaValue : [0, 100]
		});
		
		volumeDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: soundSliderButtonClassId,
			title: soundSliderButtonTitle,
			ariaHidden: [true]
		});
		volumeDocfrag.firstChild.lastChild.firstChild.appendChild(el);

		docfrag.firstChild.appendChild(volumeDocfrag);

		imageDocfrag = document.createDocumentFragment();
		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: imageDivClassId,
			ariaLabel: "image controls",
			ariaRole: "group"
		});
		imageDocfrag.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: toBeginClassId,
			title: toBeginTitle,
			tabIndex: toBeginTabIndex,
			ariaControls: videoId,
			ariaLabel: toBeginAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: fiveBackClassId,
			title: fiveBackTitle,
			tabIndex: fiveBackTabIndex,
			ariaControls: videoId,
			ariaLabel: fiveBackAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: tenBackClassId,
			title: tenBackTitle,
			tabIndex: tenBackTabIndex,
			ariaControls: videoId,
			ariaLabel: tenBackAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: tenForwardClassId,
			title: tenForwardTitle,
			tabIndex: tenForwardTabIndex,
			ariaControls: videoId,
			ariaLabel: tenForwardAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: fiveForwardClassId,
			title: fiveForwardTitle,
			tabIndex: fiveForwardTabIndex,
			ariaContros: videoId,
			ariaLabel: fiveForwardAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);
		
		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: toEndClassId,
			title: toEndTitle,
			tabIndex: toEndTabIndex,
			ariaControls: videoId,
			ariaLabel: toEndAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "button",
			type: "button",
			classId: fullscreenClassId,
			title: fullscreenTitle,
			tabIndex: fullscreenTabIndex,
			ariaControls: videoId,
			ariaLabel: fullscreenAriaLabel,
			data: ["data-fullscreen", "off"]
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: speedClassId,
			ariaRole: "radiogroup",
			ariaLabel: speedAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "input",
			type: "radio",
			classId: speedHalfClassId,
			name: speedName + "-" + (indexNr + 1),
			value: "0.5",
			title: speedHalfTitle,
			tabIndex: speedTabIndex,
			ariaControls: videoId,
			ariaLabel: speedHalfAriaLabel,
			ariaChecked: [false]
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "label",
			classId: speedHalfLabelClassId,
			isFor: speedHalfClassId,
			title: speedHalfLabelTitle,
			innerHtml: speedHalfLabelText
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "input",
			type: "radio",
			classId: speedDefaultClassId,
			name: speedName + "-" + (indexNr + 1),
			value: "1",
			title: speedDefaultTitle,
			tabIndex: speedTabIndex,
			checked: true,
			ariaControls: videoId,
			ariaLabel: speedDefaultAriaLabel,
			ariaChecked: [true]
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "label",
			classId: speedDefaultLabelClassId,
			isFor: speedDefaultClassId,
			title: speedDefaultLabelTitle,
			innerHtml: speedDefaultLabelText
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "input",
			type: "radio",
			classId: speedOneHalfClassId,
			name: speedName + "-" + (indexNr + 1),
			value: "1.5",
			title: speedOneHalfTitle,
			tabIndex: speedTabIndex,
			ariaControls: videoId,
			ariaLabel: speedOneHalfAriaLabel,
			ariaChecked: [false]
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "label",
			classId: speedOneHalfLabelClassId,
			isFor: speedOneHalfClassId,
			title: speedOneHalfLabelTitle,
			innerHtml: speedOneHalfLabelText
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "input",
			type: "radio",
			classId: speedDoubleClassId,
			name: speedName + "-" + (indexNr + 1),
			value: "2",
			title: speedDoubleTitle,
			tabIndex: speedTabIndex,
			ariaControls: videoId,
			ariaLabel: speedDoubleAriaLabel,
			ariaChecked: [false]
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "label",
			classId: speedDoubleLabelClassId,
			isFor: speedDoubleClassId,
			title: speedDoubleLabelTitle,
			innerHtml: speedDoubleLabelText
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: imageSliderClassId
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: imageSliderBeamClassId,
			title: imageSliderBeamTitle,
			tabIndex: imageSliderBeamTabIndex,
			ariaRole: "slider",
			ariaControls: videoId,
			ariaLabel: imageSliderBeamAriaLabel,
			ariaValue: [ariaStartVideoText, ariaEndVideoText]
		});
		imageDocfrag.firstChild.lastChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "div",
			classId: imageSliderButtonClassId,
			title: imageSliderButtonTitle,
			ariaHidden: [true]
		});
		imageDocfrag.firstChild.lastChild.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: elapsedClassId,
			title: elapsedTitle,
			innerHtml: "00:00",
			ariaRole: "timer",
			ariaLabel: elapsedAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: ariaElapsedClassId,
			ariaLive: "polite"
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: remainingClassId,
			title: remainingTitle,
			innerHtml: "--:--",
			ariaRole: "timer",
			ariaLabel: remainingAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);

		el = makeElement({
			indexNr: indexNr,
			tagName: "span",
			classId: durationClassId,
			title: durationTitle,
			ariaLabel: durationAriaLabel
		});
		imageDocfrag.firstChild.appendChild(el);
		
		docfrag.firstChild.appendChild(imageDocfrag);

		videoNodeList[indexNr].parentNode.insertBefore(docfrag, videoNodeList[indexNr].nextSibling);
		return true;
	}

	function noContext(e) {
		e.preventDefault();
	}

	function nextVideo(e) {
		var keyCode = e.keyCode,
			activeElement = document.activeElement,
			indexNr = parseInt(activeElement.id.substr(-1), 10) - 1;

		if (e.ctrlKey) {
			switch (keyCode) {
			case 37:
				indexNr = (isNaN(indexNr)) ? 0 : --indexNr;
				indexNr = (indexNr < 0) ? (videoNodeList.length - 1) : indexNr;
				e.preventDefault();
				break;
			case 39:
				indexNr = (isNaN(indexNr)) ? 0 : ++indexNr;
				indexNr = (indexNr >= videoNodeList.length) ? 0 : indexNr;
				e.preventDefault();
				break;
			default:
				return false;
			}
			playPauseNodeList[indexNr].focus();
		}
		return false;
	}
	
	function playPause() {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			speed;

		wrapperDivNodeList[indexNr].setAttribute("data-duration", "known");
		wrapperDivNodeList[indexNr].setAttribute("data-hour", (videoNodeList[indexNr].duration >= 3600) ? "yes" : "no");
		if (!videoNodeList[indexNr].paused && !videoNodeList[indexNr].ended) {
			videoNodeList[indexNr].pause();
			this.title = playTitle;
			if (playAriaLabel) this.setAttribute("aria-label", playAriaLabel);
			this.className = playPauseClassId + " " + notPlayingClass;
			clearInterval(elapsed);
		} else {
			speed = videoNodeList[indexNr].playbackRate;
			videoNodeList[indexNr].play();
			videoNodeList[indexNr].playbackRate = speed;
			this.title = pauseTitle;
			if (pauseAriaLabel) this.setAttribute("aria-label", pauseAriaLabel);
			this.className = playPauseClassId;
			ariaElapsedNodeList[indexNr].innerHTML = "";
			stopOthers(indexNr);
		}
	}

	function stopOthers(indexNr) {
		var len = videoNodeList.length,
		i;

		clearInterval(elapsed);
		for (i = 0; i < len; i++) {
			if (i === indexNr) {
				startTime(indexNr);
				continue;
			} else {
				videoNodeList[i].pause();
				playPauseNodeList[i].title = playTitle;
				if (playAriaLabel) playPauseNodeList[i].setAttribute("aria-label", playAriaLabel);
				playPauseNodeList[i].className = playPauseClassId + " " + notPlayingClass;
			}
		}
	}

	function finished() {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		playPauseNodeList[indexNr].title = playTitle;
		if (playAriaLabel) playPauseNodeList[indexNr].setAttribute("aria-label", playAriaLabel);
		playPauseNodeList[indexNr].className = playPauseClassId + " " + notPlayingClass;
		clearInterval(elapsed);
		showTime(indexNr);
		videoNodeList[indexNr].pause();
		ariaElapsedNodeList[indexNr].innerHTML = ariaEndVideoText;
	}

	function mute(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (videoNodeList[indexNr].muted === false) {
			videoNodeList[indexNr].muted = true;
			this.title = unmuteTitle;
			this.className = muteClassId + " " + mutedClass;
			this.setAttribute("aria-label", unmuteAriaLabel);
		} else {
			videoNodeList[indexNr].muted = false;
			this.title = muteTitle;
			this.className = muteClassId;
			this.setAttribute("aria-label", muteAriaLabel);
		}
		e.stopPropagation();
		e.preventDefault();
	}

	function soundBeginSliding(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			widthSliderButton = soundSliderButtonNodeList[indexNr].offsetWidth,
			widthSliderBeam = soundSliderBeamNodeList[indexNr].clientWidth,
			availableSpaceSliderBeam = widthSliderBeam - widthSliderButton,
			correction = availableSpaceSliderBeam / widthSliderBeam,
			counter = 0,
			len, i, xSliderBeam;

		soundSlidingAllowed = indexNr;
		xSliderBeam = getPositionX(soundSliderBeamNodeList[indexNr]);

		len = soundSliderBeamNodeList.length;
		for (i = 0; i < len; i++) {
			soundSliderBeamNodeList[i].removeEventListener("pointermove", soundSliding);
			soundSliderButtonNodeList[i].removeEventListener("pointermove", soundSliding);
			soundSliderBeamNodeList[i].removeEventListener("touchmove", soundSliding);
			soundSliderButtonNodeList[i].removeEventListener("touchmove", soundSliding);
		}
		soundSliderBeamNodeList[indexNr].addEventListener("pointermove", soundSliding);
		soundSliderButtonNodeList[indexNr].addEventListener("pointermove", soundSliding);
		soundSliderBeamNodeList[indexNr].addEventListener("touchmove", soundSliding);
		soundSliderButtonNodeList[indexNr].addEventListener("touchmove", soundSliding);

		soundSliderButtonNodeList[indexNr].style.left = Math.round(Math.max(0, Math.min(availableSpaceSliderBeam, correction * (e.clientX - xSliderBeam)))) + "px";
		showPercentageSliding(e.clientX - xSliderBeam, widthSliderBeam, indexNr);

		function soundSliding(e) {
			var screenX;

			counter++;
			if (soundSlidingAllowed === indexNr && (counter % 5 === 0)) {
				screenX = (e.type === "pointermove") ? e.clientX : e.changedTouches[0].clientX;
				soundSliderButtonNodeList[indexNr].style.left = Math.round(Math.max(0, Math.min(availableSpaceSliderBeam, correction * (screenX - xSliderBeam)))) + "px";
				showPercentageSliding(screenX - xSliderBeam, widthSliderBeam, indexNr);
			}
			e.stopPropagation();
			e.preventDefault();
		}
		e.stopPropagation();
	}

	function getPositionX(element) {
		var x = 0;

		while (element) {
			x += (element.offsetLeft + element.clientLeft);
			element = element.offsetParent;
		}
		return x;
	}

	function showPercentageSliding(place, widthSliderBeam, indexNr) {
		var percentage = Math.round(place / widthSliderBeam * 100);

		if (percentage >= 99) {
			percentage = 100;
		} else if (percentage <= 1) {
			percentage = 0;
		}

		percentageNodeList[indexNr].innerHTML = percentage + "%";
		wrapperDivNodeList[indexNr].setAttribute("data-volume", "percent-" + twoDigits(percentage));
		videoNodeList[indexNr].volume = (percentage / 100).toFixed(2);
		ariaSpeakVolume = indexNr;
	}

	function soundSliderKey(e) {
		if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey || e.accelKey) {
			return false;
		}

		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			keyCode = e.keyCode,
			percentage = parseInt(percentageNodeList[indexNr].innerHTML, 10);

		switch (keyCode) {
		case 33:
			percentage += 10;
			break;
		case 34:
			percentage -= 10;
			break;
		case 35:
			percentage = 100;
			break;
		case 36:
			percentage = 0;
			break;
		case 37:
		case 40:
			percentage--;
			break;
		case 38:
		case 39:
			percentage++;
			break;
		default:
			return false;
		}

		e.stopPropagation();
		e.preventDefault();

		showPercentageKey(percentage, indexNr);
		return false;
	}
	
	function keySofterLouder(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			keyCode = e.keyCode,
			percentage = parseInt(percentageNodeList[indexNr].innerHTML, 10);
				// Enter of spatiebalk in knop zachter

		if (e.target.className === softerClassId && (keyCode === 13 || keyCode === 32)) {
			percentage--;
		} else if (e.target.className === louderClassId && (keyCode === 13 || keyCode === 32)) {
			percentage++;
		} else {
			return false;
		}
		e.stopPropagation();
		e.preventDefault();
		showPercentageKey(percentage, indexNr);
		return false;
	}

	function pointerSofterLouder(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			percentage = parseInt(percentageNodeList[indexNr].innerHTML, 10),
			counter = 1;

		if (e.target.className === softerClassId) {
			percentage--;
		} else if (e.target.className === louderClassId) {
			percentage++;
		}
		showPercentageKey(percentage, indexNr);
		if (pointerRepeat === -1) {
			if (e.target.className === softerClassId) {
				pointerRepeat = setInterval(function () {showPercentageKey(--percentage, indexNr, counter++); }, 50);
			} else if (e.target.className === louderClassId) {
				pointerRepeat = setInterval(function () {showPercentageKey(++percentage, indexNr, counter++); }, 50);
			}
		}
		return false;
	}

	function showPercentageKey(percentage, indexNr, counter) {
		var time, difference, newTime, availableSpaceSliderBeam;

		if (counter <  3) {
			time = new Date().getTime();
			difference = 0;
			while (difference < 200) {
				newTime = new Date().getTime();
				difference = newTime - time;
			}
			return false;
		}

		if (counter === 20) {
			stopPointerRepeat();
			return false;
		}

		percentage = Math.max(0, Math.min(100, percentage));
		percentageNodeList[indexNr].innerHTML = percentage + "%";
		wrapperDivNodeList[indexNr].setAttribute("data-volume", "percent-" + twoDigits(percentage));
		videoNodeList[indexNr].volume = (percentage / 100).toFixed(2);

		availableSpaceSliderBeam = soundSliderBeamNodeList[indexNr].clientWidth - soundSliderButtonNodeList[indexNr].offsetWidth;
		soundSliderButtonNodeList[indexNr].style.left = Math.round(availableSpaceSliderBeam / 100 * percentage) + "px";

		ariaSpeakVolume = indexNr;
		
		return false;
	}

	function speakVolume() {
		var volume = (ariaSpeakVolume >= 0) ? Math.round(Math.max(0, Math.min(100, (100 * videoNodeList[ariaSpeakVolume].volume)))) : volume;

		if (isNaN(volume)) return false;

		if (videoNodeList[ariaSpeakVolume].paused || videoNodeList[ariaSpeakVolume.ended] || volume === 0 || volume === 100) {
			ariaVolumeNodeList[ariaSpeakVolume].innerHTML = volume + " " + ariaVolumeText;
			ariaSpeakVolume = -1;
		}
	
		return false;
	}

	function stopPointerRepeat(e) {
		if (pointerRepeat !== -1) {
			clearInterval(pointerRepeat);
			pointerRepeat = -1;
			e.stopPropagation();
			e.preventDefault();
		}
	}

	function toBegin() {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			return false;
		}

		videoNodeList[indexNr].currentTime = 0;
		showTime(indexNr);
		ariaElapsedNodeList[indexNr].innerHTML = ariaStartVideoText;

		return false;
	}

	function keyBackForward(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			return false;
		}

		var keyCode = e.keyCode,
			vijfPercent = 0.05 * videoNodeList[indexNr].duration;

		if (e.target.className === fiveBackClassId && (keyCode === 13 || keyCode === 32)) {
			videoNodeList[indexNr].currentTime -= vijfPercent;
		} else if (e.target.className === tenBackClassId && (keyCode === 13 || keyCode === 32)) {
			videoNodeList[indexNr].currentTime -= 10;
		} else if (e.target.className === tenForwardClassId && (keyCode === 13 || keyCode === 32)) {
			videoNodeList[indexNr].currentTime += 10;
		} else if (e.target.className === fiveForwardClassId && (keyCode === 13 || keyCode === 32)) {
			videoNodeList[indexNr].currentTime += vijfPercent;
		} else {
			return false;
		}
		e.stopPropagation();
		e.preventDefault();
		showTime(indexNr);
		ariaSpeakTime = indexNr;
		return false;
	}

	function toEnd() {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			return false;
		}

		videoNodeList[indexNr].currentTime = videoNodeList[indexNr].duration;
		ariaElapsedNodeList[indexNr].innerHTML = ariaEndVideoText;
		showTime(indexNr);

		return false;
	}
	
	function fullscreen(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			return false;
		}

		var video = videoNodeList[indexNr],
			width = getComputedStyle(video).width,
			height = getComputedStyle(video).height,
			position = getComputedStyle(video).position,
			top = getComputedStyle(video).top,
			left = getComputedStyle(video).left,
			zIndex = getComputedStyle(video).zIndex;

		if (position === "fixed" && zIndex === "137720") return false;
		
		if (video.requestFullscreen) {
			video.requestFullscreen();
		} else if (video.msRequestFullscreen) {
			video.msRequestFullscreen();
		} else if (video.mozRequestFullScreen) {
			video.mozRequestFullScreen();
		} else if (video.webkitRequestFullscreen) {
			video.webkitRequestFullscreen();
		} else {
			fullscreenNodeList[indexNr].setAttribute("data-fullscreen", "on");
			video.style.width = "100%";
			video.style.height = "100%";
			video.style.position = "fixed";
			video.style.top = "30px";
			video.style.left = "0";
			video.style.zIndex = "137720";
			document.addEventListener("pointerdown", function () {setTimeout(function () {pointerWindowedVideo(e, indexNr, video, width, height, position, top, left, zIndex); }, 500); });
			document.addEventListener("keydown", function (e) {
				if (e.keyCode === 27 && getComputedStyle(video).position === "fixed" && parseInt(getComputedStyle(video).zIndex, 10) === 137720) {
					video.style.width = width;
					video.style.height = height;
					video.style.position = position;
					video.style.top = top;
					video.style.left = left;
					video.style.zIndex = zIndex;
					fullscreenNodeList[indexNr].setAttribute("data-fullscreen", "off");
				}
			});
		}

		return false;
	}
	
	function pointerWindowedVideo(e, indexNr, video, width, height, position, top, left, zIndex) {
		fullscreenNodeList[indexNr].className = fullscreenClassId;
		video.style.width = width;
		video.style.height = height;
		video.style.position = position;
		video.style.top = top;
		video.style.left = left;
		video.style.zIndex = zIndex;
		fullscreenNodeList[indexNr].setAttribute("data-fullscreen", "off");
		e.stopPropagation();
		document.removeEventListener("pointerdown", pointerWindowedVideo);
	}

	function pointerBackForward(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;
		
		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			e.preventDefault();
			return false;
		}
		
		var	counter = 1,
			vijfPercent = 0.05 * videoNodeList[indexNr].duration,
			difference;

		if (e.target.className === fiveBackClassId) {
			videoNodeList[indexNr].currentTime -= vijfPercent;
			difference = vijfPercent;
		} else if (e.target.className === tenBackClassId) {
			videoNodeList[indexNr].currentTime -= 10;
			difference = 10;
		} else if (e.target.className === tenForwardClassId) {
			videoNodeList[indexNr].currentTime += 10;
			difference = 10;
		} else if (e.target.className === fiveForwardClassId) {
			videoNodeList[indexNr].currentTime += vijfPercent;
			difference = vijfPercent;
		}
		
		showTime(indexNr);
		ariaSpeakTime = indexNr;
		if (pointerRepeat === -1) {
			if (e.target.className === fiveBackClassId || e.target.className === tenBackClassId) {
				pointerRepeat = setInterval(function () {showTimePointer((videoNodeList[indexNr].currentTime - difference), indexNr, counter++); }, 100);
			} else if (e.target.className === fiveForwardClassId || e.target.className === tenForwardClassId) {
				pointerRepeat = setInterval(function () {showTimePointer((videoNodeList[indexNr].currentTime + difference), indexNr, counter++); }, 100);
			}
		}
		return false;
	}
	
	function showTimePointer(newCurrentTime, indexNr, counter) {
		var time, difference, newTime;

		if (counter < 3) {
			time = new Date().getTime();
			difference = 0;
			while (difference < 200) {
				newTime = new Date().getTime();
				difference = newTime - time;
			}
			return false;
		}

		if (counter === 12) {
			stopPointerRepeat();
			return false;
		}

		videoNodeList[indexNr].currentTime = newCurrentTime;
		showTime(indexNr);
		ariaSpeakTime = indexNr;
		return false;
	}

	function changeSpeed(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1,
			buttons = document.getElementsByName(this.name),
			speed = 1;

		Array.prototype.map.call(buttons, function (e) {
			speed = (e.checked) ? e.value : speed;
			e.setAttribute("aria-checked", (e.checked) ? "true" : "false");
		});

		if (!videoNodeList[indexNr].paused) {
			videoNodeList[indexNr].pause();
			videoNodeList[indexNr].playbackRate = speed;
			videoNodeList[indexNr].play();
		}

		videoNodeList[indexNr].playbackRate = speed;
		e.stopPropagation();
	}
	
	function showDuration(indexNr) {
		var duration = Math.round(videoNodeList[indexNr].duration);

		duration = toMinutes(duration);
		durationNodeList[indexNr].innerHTML = duration;
		remainingNodeList[indexNr].innerHTML = duration;
	}
	
	function toMinutes(time) {
		if (isNaN(time) || time < 0) return "--:--";
		time = Math.round(time);

		var hours = Math.floor(time / 3600),
			minutes;

		time %= 3600;
		minutes = twoDigits(Math.floor(time / 60)) + ":";
		time = twoDigits(time % 60);
		return ((hours > 0) ? hours + ":" : "") + minutes + time;
	}

	function twoDigits(number) {
		number += "";
		number = (number.length < 2) ? "0" + number : number;
		return number;
	}
	
	function obtainDurationAgain() {
		var len = videoNodeList.length,
			i, duration;

		for (i = 0; i < len; i++) {
			duration = videoNodeList[i].duration;
			if (isNaN(duration) || duration === 1 || duration === 100) {
				duration = "--:--";
			} else {
				duration = toMinutes(duration);
				wrapperDivNodeList[i].setAttribute("data-duration", "known");
				wrapperDivNodeList[i].setAttribute("data-hour", (videoNodeList[i].duration > 3600) ? "yes" : "no");
			}
			durationNodeList[i].innerHTML = duration;
			remainingNodeList[i].innerHTML = duration;
		}
	}

	function showDurationLater(indexNr) {
		var duration = videoNodeList[indexNr].duration;

		if (isNaN(duration)) {
			videoNodeList[indexNr].addEventListener("playing", function () {
				duration = toMinutes(Math.round(videoNodeList[indexNr].duration));
				durationNodeList[indexNr].innerHTML = duration;
				wrapperDivNodeList[indexNr].setAttribute("data-duration", "known");
				wrapperDivNodeList[indexNr].setAttribute("data-hour", (videoNodeList[indexNr].duration > 3600) ? "yes" : "no");
			});
		} else if (duration === 1 || duration === 100) {
			videoNodeList[indexNr].addEventListener("durationchange", function () {setTimeout(function () {showDuration(indexNr); }, 1); });
		}
	}

	function startTime(indexNr) {
		setTimeout(function () {showTime(indexNr); }, 1);
		elapsed = setInterval(function () {showTime(indexNr); }, 1000);
	}

	function showTime(indexNr) {
		var duration = Math.round(videoNodeList[indexNr].duration),
			elapsed = Math.round(videoNodeList[indexNr].currentTime),
			pxPerSecond;

		elapsedNodeList[indexNr].innerHTML = toMinutes(elapsed);
		remainingNodeList[indexNr].innerHTML = toMinutes(duration - elapsed);

		pxPerSecond = (imageSliderBeamNodeList[indexNr].clientWidth - imageSliderButtonNodeList[indexNr].offsetWidth) / duration;
		imageSliderButtonNodeList[indexNr].style.left = Math.round(Math.min(imageSliderBeamNodeList[indexNr].clientWidth, Math.max(0, (elapsed * pxPerSecond)))) + "px";

		wrapperDivNodeList[indexNr].setAttribute("data-played", "percent-" + twoDigits(Math.round((elapsed / duration) * 100)));
		return false;
	}

	function imageSliderKey(e) {
		if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey || e.accelKey || e.keyCode === 9 || e.keyCode === 13 || e.keyCode === 32) {
			return false;
		}

		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			return false;
		}

		var	keyCode = e.keyCode,
			newCurrentTime = videoNodeList[indexNr].currentTime,
			duration = videoNodeList[indexNr].duration;

		if (isNaN(duration) || isNaN(newCurrentTime)) return false;

		switch (keyCode) {
		case 33:
			newCurrentTime += (duration / 20);
			break;
		case 34:
			newCurrentTime -= (duration / 20);
			break;
		case 35:
			newCurrentTime = duration;
			break;
		case 36:
			newCurrentTime = 0;
			break;
		case 37:
		case 40:
			newCurrentTime -= 10;
			break;
		case 38:
		case 39:
			newCurrentTime += 10;
			break;
		default:
			return false;
		}

		e.stopPropagation();
		e.preventDefault();

		videoNodeList[indexNr].currentTime = newCurrentTime;
		if (newCurrentTime <= 0) {
			videoNodeList[indexNr].pause();
			playPauseNodeList[indexNr].className = playPauseClassId + " " +  notPlayingClass;
		}
		showTime(indexNr);
		ariaSpeakTime = indexNr;
		return false;
	}


	function speakTime() {
		var elapsed = (ariaSpeakTime >= 0) ? Math.round(videoNodeList[ariaSpeakTime].currentTime) : elapsed,
			hours, minutes, seconds, readOut;

		if (isNaN(elapsed)) return false;
		hours = Math.floor(elapsed / 3600);
		readOut = (hours > 0) ? hours + " " + ariaHourText + " " : "";
		elapsed %= 3600;
		minutes = Math.floor(elapsed / 60);
		readOut += (minutes > 0) ? minutes + " " + ariaMinutesText + " " : "";
		seconds = elapsed % 60;
		readOut += (seconds >= 0) ? seconds + " " + ariaSecondsText : "";
		ariaElapsedNodeList[ariaSpeakTime].innerHTML = readOut;
		ariaSpeakTime = -1;
		return false;
	}

	function imageBeginSliding(e) {
		var indexNr = parseInt(this.id.substr(-1), 10) - 1;

		if (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "unknown") {
			showDurationText(false, indexNr);
			e.preventDefault();
			return false;
		}

		var	widthSliderButton = imageSliderButtonNodeList[indexNr].offsetWidth,
			widthSliderBeam = imageSliderBeamNodeList[indexNr].clientWidth,
			availableSpaceSliderBeam = widthSliderBeam - widthSliderButton,
			duration = videoNodeList[indexNr].duration,
			correction = availableSpaceSliderBeam / widthSliderBeam,
			counter = 0,
			len, i, xSliderBeam;

		imageSlidingAllowed = indexNr;
		xSliderBeam = getPositionX(imageSliderBeamNodeList[indexNr]);

		len = imageSliderBeamNodeList.length;
		for (i = 0; i < len; i++) {
			imageSliderBeamNodeList[i].removeEventListener("pointermove", imageSliding);
			imageSliderButtonNodeList[i].removeEventListener("pointermove", imageSliding);
			imageSliderBeamNodeList[i].removeEventListener("touchmove", imageSliding);
			imageSliderButtonNodeList[i].removeEventListener("touchmove", imageSliding);
		}
		imageSliderBeamNodeList[indexNr].addEventListener("pointermove", imageSliding);
		imageSliderButtonNodeList[indexNr].addEventListener("pointermove", imageSliding);
		imageSliderBeamNodeList[indexNr].addEventListener("touchmove", imageSliding);
		imageSliderButtonNodeList[indexNr].addEventListener("touchmove", imageSliding);

		imageSliderButtonNodeList[indexNr].style.left = Math.round(Math.max(0, Math.min(availableSpaceSliderBeam, correction * (e.clientX - xSliderBeam)))) + "px";
		videoNodeList[indexNr].currentTime = (e.clientX - xSliderBeam) / availableSpaceSliderBeam * duration;
		showTime(indexNr);
		ariaSpeakTime = indexNr;

		function imageSliding(e) {
			var screenX;

			counter++;
			if (imageSlidingAllowed === indexNr && (counter % 5 === 0)) {
				screenX = (e.type === "pointermove") ? e.clientX : e.changedTouches[0].clientX;
				imageSliderButtonNodeList[indexNr].style.left = Math.round(Math.max(0, Math.min(availableSpaceSliderBeam, correction * (screenX - xSliderBeam)))) + "px";
				videoNodeList[indexNr].currentTime = (screenX - xSliderBeam) / availableSpaceSliderBeam * duration;
				showTime(indexNr);
				ariaSpeakTime = indexNr;
			}
			e.stopPropagation();
			e.preventDefault();
		}

		return false;
	}

	function showDurationText(keyboard, indexNr, keyCode) {
		var text, textParent, button, par;
	
		if (!durationUnknownText) return false;

		if (keyboard) {
			if ((keyCode !== 13 && keyCode !== 32) || (wrapperDivNodeList[indexNr].getAttribute("data-duration") === "known")) {
				return false;
			}
		}
		
		if (!showingDurationText) {
			showingDurationText = true;
			text = document.createElement("div");
			text.id = durationDivId;
			text.setAttribute("role", "dialog");
			text.setAttribute("aria-label", durationDivAriaLabel);
			text.setAttribute("aria-describedby", durationParId);
			durationButtonText = (durationButtonText) ? durationButtonText : "OK";
			text.innerHTML = "<p id='" + durationParId + "' tabindex = '-1' >" + durationUnknownText + "<button id='" + durationButtonId + "'>" + durationButtonText + "</button></p>";
			textParent = document.getElementById(controlsDivClassId + "-1");
			textParent.appendChild(text);
			par = document.getElementById(durationParId);
			par.focus();
			par.addEventListener("keyup", function (e) {
				if (e.keyCode !== 27) return false;
				textParent.removeChild(textParent.lastChild);
				showingDurationText = false;
				playPauseNodeList[indexNr].focus();
				text = null;
			});
			par.addEventListener("keydown", function (e) {
				if (e.keyCode === 16) {
					textParent.removeChild(textParent.lastChild);
					showingDurationText = false;
					playPauseNodeList[indexNr].focus();
					text = null;
				}
			});
			button = document.getElementById(durationButtonId);
			button.addEventListener("click", function () {
				textParent.removeChild(textParent.lastChild);
				showingDurationText = false;
				playPauseNodeList[indexNr].focus();
				text = null;
			});
			button.addEventListener("blur", function () {
				textParent.removeChild(textParent.lastChild);
				showingDurationText = false;
				playPauseNodeList[indexNr].focus();
				text = null;
			});
			button.addEventListener("keyup", function (e) {
				if (e.keyCode !== 27) return false;
				textParent.removeChild(textParent.lastChild);
				showingDurationText = false;
				playPauseNodeList[indexNr].focus();
				text = null;
			});
		}
	}

	function afterPageLoaded() {
		var len = soundSliderBeamNodeList.length,
			i;

		for (i = 0; i < len; i++) {
			if (getComputedStyle(soundSliderBeamNodeList[i]).position === "static") soundSliderBeamNodeList[i].style.position = "relative";
			soundSliderButtonNodeList[i].style.left = Math.round(((soundSliderBeamNodeList[i].clientWidth / (100 / (100 * soundStartVolume)))) - (soundSliderButtonNodeList[i].offsetWidth / (100 / (100 * soundStartVolume)))) + "px";
			soundSliderButtonNodeList[i].style.visibility = "visible";
			if (getComputedStyle(imageSliderBeamNodeList[i]).position === "static") imageSliderBeamNodeList[i].style.position = "relative";
			if (videoNodeList[i].readyState >= 1 && videoNodeList[i].duration !== 1 && videoNodeList[i].duration !== 100) {
				showDuration(i);
				wrapperDivNodeList[i].setAttribute("data-duration", "known");
				wrapperDivNodeList[i].setAttribute("data-hour", (videoNodeList[i].duration > 3600) ? "yes" : "no");
			} else {
				durationNodeList[i].innerHTML = "--:--";
				remainingNodeList[i].innerHTML = "--:--";
				showDurationLater(i);
			}
		}
	}
	return false;
}